> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/api-reference/network-services/api-gateway/routes/create-route.md).

# Create Route

Creates a new Route.

The full Route needs to be provided to create the object. Optional data will be filled with defaults or left empty.

```json
{"openapi":"3.0.3","info":{"title":"IONOS Cloud - API Gateway","version":"0.0.1"},"tags":[{"name":"Routes","description":"A route is a rule that maps an incoming request to a specific backend service.\n\nThis tag groups all operations for routes.\n"}],"servers":[{"url":"https://apigateway.de-txl.ionos.com","description":"Production de-txl"},{"url":"https://apigateway.gb-lhr.ionos.com","description":"Production gb-lhr"},{"url":"https://apigateway.fr-par.ionos.com","description":"Production fr-par"},{"url":"https://apigateway.es-vit.ionos.com","description":"Production es-vit"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"RouteCreate":{"type":"object","required":["properties"],"properties":{"metadata":{"description":"Metadata","additionalProperties":true},"properties":{"$ref":"#/components/schemas/Route"}}},"Route":{"type":"object","description":"A route is a rule that maps an incoming request to a specific backend service.\n","required":["name","type","paths","methods","upstreams"],"properties":{"name":{"type":"string","minLength":1,"maxLength":25,"pattern":"^[a-zA-Z0-9 _-]+$","description":"The name of the route."},"type":{"type":"string","description":"This field specifies the protocol used by the ingress to route traffic to the backend service.","default":"http"},"paths":{"type":"array","minItems":1,"items":{"type":"string","format":"path"},"description":"The paths that the route should match.\n"},"methods":{"type":"array","items":{"type":"string","enum":["GET","POST","PUT","DELETE","PATCH","OPTIONS","HEAD","CONNECT","TRACE"]},"description":"The HTTP methods that the route should match.\n"},"websocket":{"type":"boolean","default":false,"description":"To enable websocket support."},"upstreams":{"type":"array","minItems":1,"items":{"required":["scheme","loadbalancer","host","port"],"type":"object","properties":{"scheme":{"type":"string","description":"The target URL of the upstream.","enum":["http","https","grpc","grpcs"],"default":"http"},"loadbalancer":{"type":"string","description":"The load balancer algorithm.","default":"roundrobin"},"host":{"type":"string","description":"The host of the upstream. Field is validated as hostname [according to RFC1123](https://pkg.go.dev/github.com/go-playground/validator/v10#hdr-Hostname_RFC_1123).","format":"host"},"port":{"type":"integer","description":"The port of the upstream.","default":80,"minimum":1,"maximum":65535},"weight":{"type":"integer","description":"Weight with which to split traffic to the upstream.","default":100}}}},"cache":{"$ref":"#/components/schemas/Cache"}}},"Cache":{"type":"object","description":"The cache configuration for the API Gateway instance. The TTL is 60 seconds.\n","properties":{"enable":{"type":"boolean","default":false,"description":"To enable caching."},"httpMethods":{"type":"array","items":{"type":"string","enum":["GET","POST","HEAD"]},"description":"The HTTP methods that the cache should match.\n"},"httpCodes":{"type":"array","items":{"type":"integer","minimum":200,"maximum":599},"description":"The HTTP status codes that the cache should match.\n"}}},"RouteRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Route.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["route"]},"href":{"description":"The URL of the Route.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithEndpoint"},"properties":{"$ref":"#/components/schemas/Route"}}},"MetadataWithEndpoint":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","required":["publicEndpoint"],"properties":{"publicEndpoint":{"type":"string","description":"The public endpoint of the API Gateway instance.\n","readOnly":true}}}]},"MetadataWithStatus":{"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["status"],"properties":{"status":{"type":"string","description":"The status of the object. The status can be:\n* `AVAILABLE` - resource exists and is healthy.\n* `PROVISIONING` - resource is being created or updated.\n* `DESTROYING` - delete command was issued, the resource is being deleted.\n* `FAILED` - resource failed, details in `failureMessage`.\n","enum":["PROVISIONING","DESTROYING","AVAILABLE","FAILED"],"readOnly":true},"statusMessage":{"type":"string","description":"The message of the failure if the status is `FAILED`.\n","readOnly":true}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnsupportedMediaType":{"description":"### Unsupported Media Type\nThe request has an unsupported media type.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnprocessableEntity":{"description":"### Unprocessable Entity\nThe request was well-formed but was unable to be followed due to semantic errors.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/gateways/{apigatewayId}/routes":{"post":{"operationId":"apigatewaysRoutesPost","summary":"Create Route","tags":["Routes"],"description":"Creates a new Route.\n\nThe full Route needs to be provided to create the object.\nOptional data will be filled with defaults or left empty.\n","parameters":[{"name":"apigatewayId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Gateway."}],"requestBody":{"description":"Route to create.","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/RouteCreate"}}}},"responses":{"201":{"description":"Route successfully created.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RouteRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"422":{"$ref":"#/components/responses/UnprocessableEntity"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ionos.com/cloud/api-reference/network-services/api-gateway/routes/create-route.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
